// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from autoware_vehicle_msgs:msg/VelocityReport.idl
// generated code does not contain a copyright notice
#include "autoware_vehicle_msgs/msg/detail/velocity_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
autoware_vehicle_msgs__msg__VelocityReport__init(autoware_vehicle_msgs__msg__VelocityReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    autoware_vehicle_msgs__msg__VelocityReport__fini(msg);
    return false;
  }
  // longitudinal_velocity
  // lateral_velocity
  // heading_rate
  return true;
}

void
autoware_vehicle_msgs__msg__VelocityReport__fini(autoware_vehicle_msgs__msg__VelocityReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // longitudinal_velocity
  // lateral_velocity
  // heading_rate
}

bool
autoware_vehicle_msgs__msg__VelocityReport__are_equal(const autoware_vehicle_msgs__msg__VelocityReport * lhs, const autoware_vehicle_msgs__msg__VelocityReport * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // longitudinal_velocity
  if (lhs->longitudinal_velocity != rhs->longitudinal_velocity) {
    return false;
  }
  // lateral_velocity
  if (lhs->lateral_velocity != rhs->lateral_velocity) {
    return false;
  }
  // heading_rate
  if (lhs->heading_rate != rhs->heading_rate) {
    return false;
  }
  return true;
}

bool
autoware_vehicle_msgs__msg__VelocityReport__copy(
  const autoware_vehicle_msgs__msg__VelocityReport * input,
  autoware_vehicle_msgs__msg__VelocityReport * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // longitudinal_velocity
  output->longitudinal_velocity = input->longitudinal_velocity;
  // lateral_velocity
  output->lateral_velocity = input->lateral_velocity;
  // heading_rate
  output->heading_rate = input->heading_rate;
  return true;
}

autoware_vehicle_msgs__msg__VelocityReport *
autoware_vehicle_msgs__msg__VelocityReport__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  autoware_vehicle_msgs__msg__VelocityReport * msg = (autoware_vehicle_msgs__msg__VelocityReport *)allocator.allocate(sizeof(autoware_vehicle_msgs__msg__VelocityReport), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(autoware_vehicle_msgs__msg__VelocityReport));
  bool success = autoware_vehicle_msgs__msg__VelocityReport__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
autoware_vehicle_msgs__msg__VelocityReport__destroy(autoware_vehicle_msgs__msg__VelocityReport * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    autoware_vehicle_msgs__msg__VelocityReport__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
autoware_vehicle_msgs__msg__VelocityReport__Sequence__init(autoware_vehicle_msgs__msg__VelocityReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  autoware_vehicle_msgs__msg__VelocityReport * data = NULL;

  if (size) {
    data = (autoware_vehicle_msgs__msg__VelocityReport *)allocator.zero_allocate(size, sizeof(autoware_vehicle_msgs__msg__VelocityReport), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = autoware_vehicle_msgs__msg__VelocityReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        autoware_vehicle_msgs__msg__VelocityReport__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
autoware_vehicle_msgs__msg__VelocityReport__Sequence__fini(autoware_vehicle_msgs__msg__VelocityReport__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      autoware_vehicle_msgs__msg__VelocityReport__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

autoware_vehicle_msgs__msg__VelocityReport__Sequence *
autoware_vehicle_msgs__msg__VelocityReport__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  autoware_vehicle_msgs__msg__VelocityReport__Sequence * array = (autoware_vehicle_msgs__msg__VelocityReport__Sequence *)allocator.allocate(sizeof(autoware_vehicle_msgs__msg__VelocityReport__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = autoware_vehicle_msgs__msg__VelocityReport__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
autoware_vehicle_msgs__msg__VelocityReport__Sequence__destroy(autoware_vehicle_msgs__msg__VelocityReport__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    autoware_vehicle_msgs__msg__VelocityReport__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
autoware_vehicle_msgs__msg__VelocityReport__Sequence__are_equal(const autoware_vehicle_msgs__msg__VelocityReport__Sequence * lhs, const autoware_vehicle_msgs__msg__VelocityReport__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!autoware_vehicle_msgs__msg__VelocityReport__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
autoware_vehicle_msgs__msg__VelocityReport__Sequence__copy(
  const autoware_vehicle_msgs__msg__VelocityReport__Sequence * input,
  autoware_vehicle_msgs__msg__VelocityReport__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(autoware_vehicle_msgs__msg__VelocityReport);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    autoware_vehicle_msgs__msg__VelocityReport * data =
      (autoware_vehicle_msgs__msg__VelocityReport *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!autoware_vehicle_msgs__msg__VelocityReport__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          autoware_vehicle_msgs__msg__VelocityReport__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!autoware_vehicle_msgs__msg__VelocityReport__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
