// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from autoware_vehicle_msgs:srv/ControlModeCommand.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "autoware_vehicle_msgs/srv/control_mode_command.h"


#ifndef AUTOWARE_VEHICLE_MSGS__SRV__DETAIL__CONTROL_MODE_COMMAND__STRUCT_H_
#define AUTOWARE_VEHICLE_MSGS__SRV__DETAIL__CONTROL_MODE_COMMAND__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NO_COMMAND'.
enum
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Request__NO_COMMAND = 0
};

/// Constant 'AUTONOMOUS'.
enum
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Request__AUTONOMOUS = 1
};

/// Constant 'AUTONOMOUS_STEER_ONLY'.
enum
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Request__AUTONOMOUS_STEER_ONLY = 2
};

/// Constant 'AUTONOMOUS_VELOCITY_ONLY'.
enum
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Request__AUTONOMOUS_VELOCITY_ONLY = 3
};

/// Constant 'MANUAL'.
enum
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Request__MANUAL = 4
};

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in srv/ControlModeCommand in the package autoware_vehicle_msgs.
typedef struct autoware_vehicle_msgs__srv__ControlModeCommand_Request
{
  builtin_interfaces__msg__Time stamp;
  uint8_t mode;
} autoware_vehicle_msgs__srv__ControlModeCommand_Request;

// Struct for a sequence of autoware_vehicle_msgs__srv__ControlModeCommand_Request.
typedef struct autoware_vehicle_msgs__srv__ControlModeCommand_Request__Sequence
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} autoware_vehicle_msgs__srv__ControlModeCommand_Request__Sequence;

// Constants defined in the message

/// Struct defined in srv/ControlModeCommand in the package autoware_vehicle_msgs.
typedef struct autoware_vehicle_msgs__srv__ControlModeCommand_Response
{
  bool success;
} autoware_vehicle_msgs__srv__ControlModeCommand_Response;

// Struct for a sequence of autoware_vehicle_msgs__srv__ControlModeCommand_Response.
typedef struct autoware_vehicle_msgs__srv__ControlModeCommand_Response__Sequence
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} autoware_vehicle_msgs__srv__ControlModeCommand_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Event__request__MAX_SIZE = 1
};
// response
enum
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/ControlModeCommand in the package autoware_vehicle_msgs.
typedef struct autoware_vehicle_msgs__srv__ControlModeCommand_Event
{
  service_msgs__msg__ServiceEventInfo info;
  autoware_vehicle_msgs__srv__ControlModeCommand_Request__Sequence request;
  autoware_vehicle_msgs__srv__ControlModeCommand_Response__Sequence response;
} autoware_vehicle_msgs__srv__ControlModeCommand_Event;

// Struct for a sequence of autoware_vehicle_msgs__srv__ControlModeCommand_Event.
typedef struct autoware_vehicle_msgs__srv__ControlModeCommand_Event__Sequence
{
  autoware_vehicle_msgs__srv__ControlModeCommand_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} autoware_vehicle_msgs__srv__ControlModeCommand_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // AUTOWARE_VEHICLE_MSGS__SRV__DETAIL__CONTROL_MODE_COMMAND__STRUCT_H_
